VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cCheckFileTime"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Checks file times even on remote files.  Also creates files, checks thier dates and times then removes those files (usful for verifying remote system dates and times"
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable(s) to hold property value(s)
Private mvarcFileToCheck As String 'local copy
Private mvariDayValue As Integer 'local copy
Private mvariMonthValue As Integer 'local copy
Private mvariYearValue As Integer 'local copy
Private mvariHourValue As Integer 'local copy
Private mvariMinuteValue As Integer 'local copy
Private mvariSecondValue As Integer 'local copy
Private mvarvFullFileDate As Variant
Private mvarvFileDateTime As Variant

Private Const MAX_PATH = 260
Private Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, lpFindFileData As WIN32_FIND_DATA) As Long

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type
Private Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Private Declare Function FileTimeToLocalFileTime Lib "kernel32" (lpFileTime As FILETIME, lpLocalFileTime As FILETIME) As Long

Public Property Get dtFullFileDate() As Variant
    dtFullFileDate = mvarvFullFileDate
End Property

Public Property Get testFileDateTime() As Variant
    testFileDateTime = mvarvFileDateTime
End Property

Public Property Get iSecondValue() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.iSecondValue
    iSecondValue = mvariSecondValue
End Property



Public Property Get iMinuteValue() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.iMinuteValue
    iMinuteValue = mvariMinuteValue
End Property



Public Property Get iHourValue() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.iHourValue
    iHourValue = mvariHourValue
End Property



Public Sub doFullFileCheck()

'''''''''''''''''''''''''''''''''''''''''
''  doFullFileCheck routine
''  desc:   part of Robert Smith's GMT solution class
''          cCheckFileTime
''          gets a remote machine's GMT/UTC date/time
''          by creating a temporary file at a read/write path
''          reading the file cration stamp
''          then deleting the file
''
''  Robert C. Smith  smith@Smithvoice.com
''  created August 1998

Dim sFileToCheckDate As String
Dim vChkDateTime As Variant

On Error GoTo err_handler
sFileToCheckDate = mvarcFileToCheck

If Dir$(sFileToCheckDate) <> "" Then
    Kill sFileToCheckDate
End If
Dim FileNumber
    FileNumber = FreeFile   ' Get unused file
    Open sFileToCheckDate For Output As #FileNumber ' Create filename.
    Write #FileNumber, "This file may be deleted."  ' Output text.
    Close #FileNumber   ' Close file.

Dim tempWinfinddata As WIN32_FIND_DATA
Dim tempFileTime As FILETIME
Dim iret As Long
Dim iret2 As Long
Dim tempSystemTime As SYSTEMTIME

'VB's FileDateTime is not useful as it returns the system format time
'of the file's modified date value
'this value is set by the machine that created the file
'but you want to know the date of the machine on which the file resides!
'we include it here for your testing only
mvarvFileDateTime = FileDateTime(sFileToCheckDate)


iret = FindFirstFile(sFileToCheckDate, tempWinfinddata)

'ftCreationDate returns remote machine GMT
tempFileTime = tempWinfinddata.ftCreationTime ''returns date from computer that holds the file

'ftLastWriteTime returns LOCAL machine GMT, this is not useful
'because this value is set with the system time of the machine that writes it!
'we include it here for your testing
'tempFileTime = tempWinfinddata.ftLastWriteTime 'returns date from computer that created file

iret2 = FileTimeToSystemTime(tempFileTime, tempSystemTime)

With tempSystemTime
    mvariDayValue = .wDay
    mvariMonthValue = .wMonth
    mvariYearValue = .wYear
    mvariHourValue = .wHour
    mvariMinuteValue = .wMinute
    mvariSecondValue = .wSecond

    vChkDateTime = DateSerial(.wYear, .wMonth, .wDay) & " " & TimeSerial(.wHour, .wMinute, .wSecond)
    If IsDate(vChkDateTime) Then mvarvFullFileDate = CDate(vChkDateTime)
End With

If Dir$(sFileToCheckDate) <> "" Then
    Kill sFileToCheckDate
End If
Exit Sub

err_handler:
'much better handling is requreid in real app, but this shoudl get the test errors

If Err.Number <> 0 Then
    MsgBox Err.Number & vbCr & Err.Description & vbCr & "Occured in DoFullFileCheck"
    Err.Clear
    Exit Sub
End If
End Sub


Public Property Get iYearValue() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.iYearValue
    iYearValue = mvariYearValue
End Property



Public Property Get iMonthValue() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.iMonthValue
    iMonthValue = mvariMonthValue
End Property



Public Property Get iDayValue() As Integer
'used when retrieving value of a property, on the right side of an assignment.
'Syntax: Debug.Print X.iDayValue
    iDayValue = mvariDayValue
End Property


Public Property Let cFileToCheck(ByVal vData As String)
'used when assigning a value to the property, on the left side of an assignment.
'Syntax: X.cFileToCheck = 5
    mvarcFileToCheck = vData
End Property



